package com.jiuqi.mde;

import java.util.Iterator;
import java.util.HashMap;
import java.util.Map;

public final class MDETableSet
{
    private Map tables;
    
    public MDETableSet() {
        this.tables = new HashMap(83);
    }
    
    public int size() {
        return this.tables.size();
    }
    
    public void clear() {
        this.tables.clear();
    }
    
    public MDETable get(final String name) {
        return this.tables.get(name);
    }
    
    public void put(final MDETable table) {
        final Map newMap = new HashMap(this.tables);
        newMap.put(table.getName(), table);
        this.tables = newMap;
    }
    
    public void putAll(final MDETableSet tables) {
        final Map newMap = new HashMap(this.tables);
        for (final MDETable table : tables) {
            newMap.put(table.getName(), table);
        }
        this.tables = newMap;
    }
    
    public void remove(final MDETable table) {
        final Map newMap = new HashMap(this.tables);
        newMap.remove(table);
        this.tables = newMap;
    }
    
    public Iterator iterator() {
        return this.tables.values().iterator();
    }
    
    public Object clone() {
        final MDETableSet result = new MDETableSet();
        result.putAll(this);
        return result;
    }
}
